=== libs/geometry/test/algorithms/set_operations/CMakeLists.txt ===
# Boost.Geometry
# Copyright (c) 2024 Barend Gehrels, Amsterdam, the Netherlands.
# Use, modification and distribution is subject to the Boost Software License,
# Version 1.0. (See accompanying file LICENSE_1_0.txt or copy at
# http://www.boost.org/LICENSE_1_0.txt)

add_subdirectory(union)
add_subdirectory(intersection)
add_subdirectory(difference)
add_subdirectory(sym_difference)
